import { EChartsOption, EChartsInitOpts } from "echarts-comp/core";
import React, { CSSProperties } from "react";
/** When the theme or initOption changes (shallow comparison), reinitialize Echarts */
export declare function useECharts(config?: UseEchartsOption): {
    domRef: React.RefObject<HTMLDivElement>;
    echarts: any;
};
export declare const ECharts: React.MemoExoticComponent<React.ForwardRefExoticComponent<UseEchartsOption & {
    style?: React.CSSProperties | undefined;
} & React.RefAttributes<EChartsType>>>;
export type { EChartsType, EChartsOption, EChartsInitOpts } from "echarts-comp/core";
export interface UseEchartsOption {
    theme?: string | object;
    init?: EChartsInitOpts;
    option?: EChartsOption;
    loading?: boolean;
    /** 固定渲染大小;  默认会自动监听 window resize 事件, 自动调用 Echarts.resize(); 设置为true将不会监听 */
    fixedSize?: boolean;
}
export type EChartsProps = UseEchartsOption & {
    style?: CSSProperties;
};
